package org.kantega.jexmec;

/*
 * Copyright 2009 Kantega AS
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * This interface defines a strategy for the discovery and removal of
 * plugin class loaders.
 */
public interface ClassLoaderStrategy extends Lifecycle{
    /**
     * Add a {@link org.kantega.jexmec.ClassLoaderListener}
     * which methods will be invoked when a ClassLoader is discovered or removed
     * @param listener the {@link org.kantega.jexmec.ClassLoaderListener} to add
     */
    void addClassLoaderListener(ClassLoaderListener listener);
    /**
     * Remove a previously added {@link org.kantega.jexmec.ClassLoaderListener}
     * which methods will be invoked when a ClassLoader is discovered or removed
     * @param listener the {@link org.kantega.jexmec.ClassLoaderListener} to remove
     */
    void removeClassLoaderListener(ClassLoaderListener listener);
}
