package org.kantega.jexmec;

/**
 * Provides access to a service of type T by name. Used by {@link org.kantega.jexmec.simple.SimplePluginLoader}
 * to give plugins access a named service of a type of which there are multiple implementations available.
 * @see SimplePluginLoader
 */
public interface NamedService<T> {
    /**
     * Returns the service named <code>name</code>
     * @param name the name of the service to return
     * @return the service named <code>name</code>
     */
    public T get(String name);
}
