package org.kantega.jexmec;

/**
 */
public class ServiceKey {
    private Class serviceClass;
    private String serviceName;

    public ServiceKey(Class serviceClass, String serviceName) {
        this.serviceClass = serviceClass;
        this.serviceName = serviceName;
    }

    public ServiceKey(Class serviceClass) {
        this(serviceClass, null);
    }

    public Class getServiceClass() {
        return serviceClass;
    }

    public String getServiceName() {
        return serviceName;
    }

    @Override
    public int hashCode() {
        if(serviceName == null) {
            return serviceClass.hashCode();
        } else {
            return serviceClass.hashCode() ^ serviceName.hashCode();
        }
    }

    @Override
    public boolean equals(Object o) {
        if(o.getClass() != ServiceKey.class) {
            return false;
        }
        ServiceKey key = ServiceKey.class.cast(o);

        if(serviceClass != key.getServiceClass()) {
            return false;
        }
        if(serviceName == null && key.getServiceName() != null) {
            return false;
        }
        if(serviceName != null && key.getServiceName() == null) {
            return false;
        }

        if(serviceName != null && !serviceName.equals(key.getServiceName())) {
            return false;
        }
        return true;
    }
}
