package org.kantega.jexmec;

/*
 * Copyright 2009 Kantega AS
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import java.util.Set;

/**
 * This interface is responsible for getting the {@link Class}es for service
 * interfaces available from the application.
 * @see DefaultServiceTypesProvider
 */
public interface ServiceTypesProvider {
    /**
     * Returns the service interfaces available in the application
     *
     * @return a collection of service interface classes
     */
    Set<ServiceKey> getServiceKeys();
}
